# Data exchange contract

CYFS proposes a data exchange contract scheme, which further expands the boundaries of trusted computing. Let trusted computing not have to all run on the blockchain. The theory of data property rights, which the data exchange contract theory relies on, completely describes the evolution process of human credible information, and calls this process the right to data network, CYFS. As the definition of Web3.0. Under the guidance of this new theory, we can make the traditional Web2.0 applications that ordinary people use every day become credible and decentralized. This article will elaborate on the design ideas and operating principles of the authorized data network (CYFS computing network).
In CYFS, the trusted operation of data exchange contracts does not depend on blockchain technology, and can become the basic component of trusted computing off-chain.

# DAOs

## What is DAO

DAO is the abbreviation of Decentralized Autonomous Organization in English. It is an organizational form derived from the core idea of ​​blockchain (co-creation, co-construction, co-governance, and sharing of collaborative behaviors spontaneously generated by groups that reach the same consensus). It is a subsidiary product after the blockchain solves the trust problem between people.
DAO is an evolutionary version of the organizational form of the company, a revolutionary evolution in the history of human collaboration. Its essence is a form of blockchain technology application.

## 3 essential elements of DAO

A DAO must have three basic elements:

1. Have organizational goals and organizational culture (organization's mission, vision, values) that can reach consensus with strangers.
2. It has a rule system including creation, governance, incentives, etc. that can reach consensus with strangers, and this rule is placed on the chain through blockchain technology.
3. Have Tokens that can form interest associations with all participants to achieve full incentives.

## What are the characteristics of DAO

A DAO is a form of organization that encodes an organization's management and operational rules on the blockchain in the form of smart contracts, thereby operating autonomously without centralized control or third-party intervention.
DAO is expected to become a new type of effective organization to deal with uncertain, diverse and complex environments.
DAO has the characteristics of full openness, autonomous interaction, decentralized control, complexity and diversity, and emergence. Unlike traditional organizational phenomena, DAOs are not limited by the space of the real physical world, and their evolution process is driven by events or goals, forming rapidly, spreading, and highly interactive, and automatically disbanding with the disappearance of goals.
DAO has the following characteristics:

1. Distributed and decentralized
   There is no central node and hierarchical management structure [30] in DAO, which achieves organizational goals through the interaction, competition and cooperation between bottom-up network nodes. Therefore, the business transactions between nodes and nodes and between nodes and organizations in DAO are no longer determined by administrative affiliation, but follow the principles of equality, voluntariness, reciprocity, and mutual benefit, and are determined by each other's resource endowments, complementary advantages and interests Driven by win-win. Each organizational node will cooperate effectively under the incentive mechanism of the token according to its own resource advantages and talents, thereby generating a strong synergistic effect.
2. Autonomous and automated
   In an ideal DAO, management is coded, programmatic, and automated. "Code is law" (code is law), the organization is no longer a pyramid but distributed, power is no longer centralized but decentralized, management is no longer bureaucratic but community autonomy, organizational operation is no longer Companies are needed but replaced by highly autonomous communities. In addition, since DAO operates under the operating standards and collaboration mode jointly determined by stakeholders, it is easier to achieve consensus and trust within the organization, which can minimize the organization's trust cost, communication cost and transaction cost.
3. Organized and ordered
   Relying on smart contracts, the operation rules in DAO, the responsibilities and rights of participants, and the reward and punishment mechanism are all open and transparent. In addition, through a series of efficient self-governance principles, the rights and interests of the relevant participants are precisely differentiated and dimensionally reduced, that is, the corresponding rights and benefits are matched to those individuals who work, make contributions, and assume responsibilities, so as to promote industrial division of labor and rights, Responsibilities and interests are equal, making the organization run more coordinated and orderly.
4. Intelligence and tokenization
   The bottom layer of DAO encapsulates all the infrastructure supporting DAO and its derived applications - Internet basic protocols, blockchain technology, artificial intelligence, big data, Internet of Things, etc. as technical support, with digital, intelligent, on-chain and off-chain collaboration Governance is a means of governance, which changes the traditional bureaucratic system and artificial management methods, and realizes the intelligent management of the organization. As an important incentive in the DAO governance process, token digitizes and tokenizes various elements in the organization (such as people, organizations, knowledge, events, products, etc.), thereby enabling monetary capital, human capital and other elements. Capital is fully integrated to better stimulate organizational efficiency and realize value transfer.
