mod state;
mod snapshot_manager;
mod storage;
mod storage_manager;
mod sql_state;

pub use state::*;
pub use storage::{Storage, StorageRef, storage_in_mem_path};
pub use snapshot_manager::{Snapshot};
pub use storage_manager::StorageManager;
pub use sql_state::*;
use crate::AnsiDBTransactionSqlCreator;

pub type MetaDatabase = sqlx::Sqlite;
pub type MetaConnection = sqlx::pool::PoolConnection<MetaDatabase>;
pub type MetaConnectionOptions = sqlx::sqlite::SqliteConnectOptions;
pub type MetaTransactionSqlCreator = AnsiDBTransactionSqlCreator;
